<?php 
/*-------------------------------Admin functions------------------------------*/

add_action( 'admin_menu', 'wpur_admin_menu' );
function wpur_admin_menu() {
	add_menu_page('WP Ultimate Review Pro', 'WP Ultimate Reviews Pro',  'edit_pages', 'wpur', 'wpur_view_reviews', 'dashicons-admin-comments', 11  );
    add_submenu_page( 'wpur', 'View All Reviews', 'View All Reviews', 'edit_pages', 'wpur_view_reviews', 'wpur_view_reviews');
    add_submenu_page( 'wpur', 'Create a Review', 'Create a Review', 'edit_pages', 'wpur_add_reviews', 'wpur_add_reviews');
    add_submenu_page( 'wpur', 'Shortcode Generator', 'Shortcode Generator', 'edit_posts', 'wpur_shortcodes', 'wpur_shortcode_generator'  );

    add_submenu_page( 'null', 'Remove Review', 'Remove Review', 'edit_pages', 'wpur_remove_review_page', 'wpur_remove_review_page');
    add_submenu_page( 'null', 'Activate Review', 'Activate Review', 'edit_pages', 'wpur_act_review', 'wpur_act_review');
    add_submenu_page( 'null', 'Deactivate Review', 'Deactivate Review', 'edit_pages', 'wpur_deact_review', 'wpur_deact_review');
}

//Show shortcode generator page
function wpur_shortcode_generator(){
    wp_enqueue_style('admin-css', plugins_url( '../css/admin.css' , __FILE__ ));
    wp_enqueue_script( 'create-shortcode', plugins_url( '../js/create-shortcode-script.js' , __FILE__ ), array('jquery'), '1.0.0', true );
    include( plugin_dir_path( __FILE__ ) . '../admin/wpur-shortcode-generator.php');
}

//Admin - Show all reviews in a list
function wpur_view_reviews(){ 

    wp_enqueue_style('admin-css', plugins_url( '../css/admin.css' , __FILE__ ));
    wp_enqueue_script( 'view-all-reviews', plugins_url( '../js/view-all-reviews-script.js' , __FILE__ ), array('jquery'), '1.0.0', true );

    global $html;
    $html = "";

   
    if($_POST['wpur_add']==1 && wp_verify_nonce($_POST['wpur_nonce'], '_review_wpur_add_nonce')){
    
            //Create new review
            $added = wpur_create_review($_POST['page_id'],$_POST['_type'],$_POST['_name'],$_POST['_email'],$_POST['_message'],$_POST['_status'],$_POST['_rating'],$_POST['_order']);
    }


    wp_enqueue_style('admin-css', plugins_url( '../css/admin.css' , __FILE__ ));
    wp_enqueue_script( 'create-review', plugins_url( '../js/create-review-script.js' , __FILE__ ), array('jquery'), '1.0.0', true );


    if(isset($added) && $added==1 ){
                $html="<div class='success'>Review has been successfully added.</div>";
    }else if(isset($added) && $added!=1 ){
                $html="<div class='error'>Error - Review could not be added at this time</div>";
    }else if(@$_GET['del']==1){
                $html="<div class='success'>Review has been successfully removed.</div>";
    }else if(@$_GET['del']==-1){
                $html="<div class='error'>Error - Review could not be removed at this time.</div>";
    }else if(@$_GET['dels']==1){
                $html="<div class='success'>Reviews have been successfully removed.</div>";
    }else if(@$_GET['dels']==-1){
                $html="<div class='error'>Error - One or more review could not be removed at this time. Please check the results in the table below.</div>";
    }else if(@$_GET['edit']==1){        
                $html="<div class='success'>Review has been successfully edited.</div>";
    }else if(@$_GET['edit']==-1){
                $html="<div class='error'>Error - Review could not be edited at this time.</div>";
    }else if(@$_GET['act']==1){
                $html="<div class='success'>Review has been enabled.</div>";
    }else if(@$_GET['act']==-1){
                $html="<div class='error'>Error - Review could not be enabled at this time.</div>";
    }else if(@$_GET['acts']==1){
                $html="<div class='success'>Reviews have been enabled.</div>";
    }else if(@$_GET['acts']==-1){
                $html="<div class='error'>Error - One or more reviews could not be enabled at this time. Please check the results in the table below.</div>";
    }else if(@$_GET['deact']==1){
                $html="<div class='success'>Review has been disabled.</div>";
    }else if(@$_GET['deact']==-1){
                $html="<div class='error'>Error - Review could not be disabled at this time.</div>";
    }else if(@$_GET['deacts']==1){
                $html="<div class='success'>Reviews have been disabled.</div>";
    }else if(@$_GET['deacts']==-1){
                $html="<div class='error'>Error - One or more reviews could not be disabled at this time. Please check the results in the table below.</div>";
    }


    include( plugin_dir_path( __FILE__ ) . '../admin/wpur-view-all-reviews.php');
}
//Admin - Add review
function wpur_add_reviews(){ 

    wp_enqueue_style('admin-css', plugins_url( '../css/admin.css' , __FILE__ ));
    wp_enqueue_script( 'create-review', plugins_url( '../js/create-review-script.js' , __FILE__ ), array('jquery'), '1.0.0', true );
    include( plugin_dir_path( __FILE__ ) . '../admin/wpur-create-review.php');
}

//Get all Woocommerce Products, if Woocommerce installed
function wpur_woocommerce_products($id){

   //$args = array('hierachical' => '1', 'post_type' => 'product');//
      /*'sort_order'   => 'ASC',
      'sort_column'  => 'post_title',
      'hierarchical' => 1,*/
      /*'name' => $id,*/
      /*'id' => $id,*/
     // 'post_type' => 'product'
   //);
//echo "TEST";
    //wp_dropdown_pages($args);


    global $wpdb;
    $posts = $wpdb->prefix . 'posts';
    $sql = "SELECT ID,post_title FROM {$posts} WHERE post_type='product' and post_status='publish';";
    $results = $wpdb->get_results($wpdb->prepare($sql, [] ) );
    $html = "<select name='".$id."' id='".$id."'>";
    foreach($results as $res){
      $html.="<option value='".$res->ID."'>".$res->post_title."</option>";
    }
    $html.="</select>";
    echo $html;
}

function wpur_get_edd_product( $pid ){
    global $wpdb;
    $posts = $wpdb->prefix . 'posts';
    $sql = "SELECT post_title FROM {$posts} WHERE post_type='download' and ID=%d and post_status='publish';";
    $var = $wpdb->get_var($wpdb->prepare($sql, array($pid) ) );
    return $var;
}

function wpur_get_woo_product( $pid ){
    global $wpdb;
    $posts = $wpdb->prefix . 'posts';
    $sql = "SELECT post_title FROM {$posts} WHERE post_type='product' and ID=%d and post_status='publish';";
    $var = $wpdb->get_var($wpdb->prepare($sql, array($pid) ) );
    return $var;
}

function wpur_footer(){
  global $wpur_version;
  return "<div class='admin-footer'><div class='admin-footer-left'>WP Ultimate Reviews Pro <strong>v".$wpur_version."</strong> developed by <a href='https://www.jamestibbles.co.uk' style='color:#6ca23a;' target='_blank'>www.jamestibbles.co.uk</a></div><div class='admin-footer-right'>Need help? Need a bespoke plugin, a custom website or web hosting? <a href='https://www.jamestibbles.co.uk/contact/' style='color:#6ca23a;' target='_blank'>Contact Me</a>.</div></div>";
}

function wpur_plugin_exists($what){

  if($what == "woocommerce"){
    if ( ! function_exists( 'is_woocommerce_activated' ) ) {
        return class_exists( 'woocommerce' );
    }else{
      return false;
    }

  }else if($what == "easy digital downloads"){
        return class_exists( 'Easy_Digital_Downloads' );
  }else{
    return false;
  }
}

//Get type of review (page, woocommerce product or edd product)
/*function wpur_get_type($id){
    global $wpdb;
    $posts = $wpdb->prefix . 'posts';
    $sql = "SELECT post_type FROM {$posts} WHERE ID=%d and post_status='publish';";
    $var = $wpdb->get_var($wpdb->prepare($sql, array($pid) ) );
    if($var == "download"){
      $var = "edd";
    }else if($var == "product"){
      $var = "woo";
    }else if($var == "post"){
      $var = "pg";
    }
    return $var;

}*/



function wpur_get_admin_table(){
  global $wpdb;
  global $wpur_reviews;
  $html = "";
  if(isset($_GET['pg'])){
                $page = $_GET['pg'];
  }else{
                $page = 1;
  }
 
  if($page<1){
                $page=1;
  }
  $where = "";
  $order = "ORDER BY a._created Desc";
            if(@$_GET['filter-email']!=""){
                if($where == ""){$where = "WHERE ";}else{$where .= " AND ";}
                $where .= "(a._email = '".$_GET['filter-email']."' or a._email REGEXP '".$_GET['filter-email']."' )";
            }
            if(@$_GET['filter-name']!=""){
                if($where == ""){$where = "WHERE ";}else{$where .= " AND ";}
                $where .= "(a._name = '".$_GET['filter-name']."' or a._name REGEXP '".$_GET['filter-name']."' )";
            }
            if(@$_GET['filter-rating']!=""){
                if($where == ""){$where = "WHERE ";}else{$where .= " AND ";}
                $where .= "(a._rating = ".$_GET['filter-rating']." )";
            }
            if(@$_GET['filter-status']!=""){
                if($where == ""){$where = "WHERE ";}else{$where .= " AND ";}
                $where .= "(a._active = ".$_GET['filter-status']." )";
            }

            if(@$_GET['filter-sort']!=""){

                $order = "ORDER BY ";
                if($_GET['filter-sort']=='email'){
                    $order .= "a._email "; 
                }else if($_GET['filter-sort']=='name'){
                    $order .= "a._name "; 
                }else if($_GET['filter-sort']=='type'){
                    $order .= "a._type"; 
                }else if($_GET['filter-sort']=='newest'){
                    $order .= "a._created "; 
                }else if($_GET['filter-sort']=='updated'){
                    $order .= "a._updated "; 
                }else if($_GET['filter-sort']=='rating'){
                    $order .= "a._rating "; 
                }
                if($order != "ORDER BY " && @$_GET['filter-ascdesc']=="asc"){
                    $order .= "asc";
                }else if($order != "ORDER BY " && @$_GET['filter-ascdesc']=="desc"){
                    $order .= "desc";
                }
                
            }


            $sql = "SELECT COUNT(a.id) as cnt FROM {$wpur_reviews} a ".$where;
            $count = $wpdb->get_var($wpdb->prepare($sql, array() ) );

            $perpage=50;
            if($page>1){
                $start = ( ($page)*$perpage)-($perpage);
            }else{
                $start=0;
            }
            $sql = "SELECT a.* FROM {$wpur_reviews} a ".$where." ".$order." LIMIT %d, %d";
            $results = $wpdb->get_results($wpdb->prepare($sql, array($start,$perpage) ) );

            $brs = array("<br>","<br />","<BR>","<BR />");
   
            foreach($results as $key => $row) {
            
                        $total++;
                        $theid = $row->id;
                        $act= $row->_active;

                        $html.="<tr";

                        if($act==0){
                            $html.=" style='background-color:#FFEFEF !important;'";
                        }else if($act==-1){
                            //to be administered
                            $html.=" style='background-color:#fffaef !important;'";
                        }
                        $html.=">";


                        $acttext = '';
                        if($act==-1){
                            $acttext = "Unmoderated";
                        }else if($act==0){
                            $acttext = "Disabled";
                        }else if($act==1){
                            $acttext = "Enabled";
                        }

                        $relation = "Global / Default";
                        if($row->_pid>0 && $row->_type=="page"){
                            $relation = "Page:<br>".get_the_title( $row->_pid);
                        }else if($row->_pid>0 && $row->_type=="woo"){
                            $product = wc_get_product( $row->_pid );
                            $relation = "Woocommerce:<br>".$product->get_title();
                        }else if($row->_pid>0 && $row->_type=="edd"){
                            $relation = "EDD product:<br>".wpur_get_edd_product( $row->_pid );
                        }


                        if(stripslashes($row->_email)==""){
                            $email = "-none-";
                        }else{
                            $email = stripslashes($row->_email);
                        }

                        $order = $row->_order;

                    

                        $html.="<td class='center'><input type='checkbox' class='multi-check 'name='multi-check' value='".$row->id."' /></td><td class='center'>".$relation."</td><td class='center'><input type='number' value='".$order."' id='order_".$row->id."' size='80' /><br><button class='button edit-order-btn' data-id='".$theid."' style='width: 100%;margin-top:5px;' data-label='Update Order'>Update Order</button></td><td class='center'><input type='text' value='".stripslashes($row->_name)."' id='reviewer_".$row->id."' size='180' /><br><button class='button edit-name-btn' data-id='".$theid."' style='width: 100%;margin-top:5px;' data-label='Update Name'>Update Name</button></td><td class='center'>".$email."</td><td  class='center' style='width:100px !important;'>".stripslashes($row->_rating)." / 5</td><td class='center'><textarea style='min-height:100px;' id='review_".$row->id."'>".str_replace($brs,"\n",stripslashes($row->_review))."</textarea><br><button class='button edit-review-btn' data-id='".$theid."' style='width: 100%;margin-top:5px;max-width: 500px;' data-label='Update Review'>Update Review</button></td><td class='center' style='width:100px !important;'>".$acttext."</td><td class='center'>".$row->_created."</td><td class='center'>";

                        if($act==-1){
                            $html.="<button class='button act-btn' data-id='".$theid."' style='width: 100%;margin-bottom:3px;'>Enable</button><br><button class='button deact-btn' data-id='".$theid."' style='width: 100%;margin-bottom:3px;'>Disable</button>";
                        }else if($act==0){
                            $html.="<button class='button act-btn' data-id='".$theid."' style='width: 100%;margin-bottom:3px;'>Enable</button>";
                        }else if($act==1){
                            $html.="<button class='button deact-btn' data-id='".$theid."' style='width: 100%;margin-bottom:3px;'>Disable</button>";
                        }
                        $html.="<br><button class='button delete-btn' data-id='".$theid."' style='width: 100%;'>Remove Review</button></td>";
                   

                        $html.="</td></tr>";
                       
            }
            if(count($results) == 0){
                $html.="<tr><td colspan='11'><i>No results found.<br><Br><a href='admin.php?page=wpur_add_reviews'>Click here to create one</a></i></td></tr>";      
            }
            return  array($html,$count,$perpage,$page);
}

?>