<?php 
/* Review and Rating functions */


//remove review
function wpur_remove_review_page(){
    if( current_user_can('editor') || current_user_can('administrator') ){
        global $wpdb;
        
        $params= "pg=".(isset($_GET['pg']) ? $_GET['pg'] : "")."&filter-name=".(isset($_GET['filter-name']) ? $_GET['filter-name'] : "");
        $params.="&filter-rating=".(isset($_GET['filter-rating']) ? $_GET['filter-rating'] : "")."&filter-sort=".(isset($_GET['filter-sort']) ? $_GET['filter-sort'] : "");
        $params.="&filter-ascdesc=".(isset($_GET['filter-ascdesc']) ? $_GET['filter-ascdesc'] : "");

        if(isset($_GET['delid'])){
            if(wpur_remove_review($_GET['delid'])){
                echo '<script>window.location = "admin.php?page=wpur_view_reviews&del=1&'.$params.'";</script>'; 
            }else{
                echo '<script>window.location = "admin.php?page=wpur_view_reviews&del=-1&'.$params.'";</script>';
            }
        }else if(isset($_GET['theids'])){
            $id_array = explode("|",$_GET['theids']);#
            $ok = true;
            foreach($id_array as $id){
                if($id>0){
                    if(!wpur_remove_review($id)){
                        $ok = false;
                    }
                }
            }
            if($ok){
                 echo '<script>window.location = "admin.php?page=wpur_view_reviews&dels=1&'.$params.'";</script>';
            }else{
                echo '<script>window.location = "admin.php?page=wpur_view_reviews&dels=-1&'.$params.'";</script>';
            }
        }
    }
}


function wpur_remove_review($id){

    if (current_user_can( 'edit_posts' ) ) {
        global $wpdb;
        global $wpur_reviews;

        $pid = $wpdb->get_var($wpdb->prepare("SELECT _pid from {$wpur_reviews} WHERE id=%d;",array($id) )); 

        $wpdb->delete( $wpur_reviews, array( 'id' => $id ), array( '%d' ) );

        return true;

    }else{

        return false;

    }
}



//update name or review via ajax
function wpur_update_review() {

   $id = (int) $_POST['_review_id'];
   $order = (int) $_POST['_review_order'];
   $name = sanitize_text_field(@$_POST['_review_name']);
   $review = wp_kses( @$_POST['_review_review'], array( 
        'a' => array(
            'href' => array(),
            'title' => array(),
            'target' => array()
        ),
        'br' => array(),
        'em' => array(),
        'strong' => array(),
    ));

   $nonce = sanitize_text_field($_POST['_wpur_nonce']);

   if(  $id!="" && 
        ($name!="" || $review!="" || $order!="") && 
        wp_verify_nonce($nonce, '_review_wpur_edit_nonce')  
    ){

        global $wpdb;
        global $wpur_reviews;

        $format = array(
                    '%s',
                    '%s'
        );

        if($name!=""){
            $data = array(
                    '_name' => $name,
                    '_updated' => current_time( 'mysql' )
            );
        }else if($review!=""){
            $data = array(
                    '_review' => $review,
                    '_updated' => current_time( 'mysql' )
            );            
        }else if($order!=""){
            $data = array(
                    '_order' => (int) $order,
                    '_updated' => current_time( 'mysql' )
            );     
            $format = array(
                    '%d',
                    '%s'
            );       
        }

            
        
        $success=$wpdb->update( $wpur_reviews, $data, array( 'id' => $id ), $format, array( '%d' ) );

        if(!$success){
            echo "0";
        }else{
            echo "1";
        }

   }else{
     echo "0";
   }

   wp_die();
}
add_action( 'wp_ajax_wpur_update_review', 'wpur_update_review' );
add_action( 'wp_ajax_nopriv_wpur_update_review', 'wpur_update_review' );

//Activate a review
function wpur_act_review(){

    if( current_user_can('editor') || current_user_can('administrator') ){

        global $wpdb;

        $params= "pg=".(isset($_GET['pg']) ? $_GET['pg'] : "")."&filter-name=".(isset($_GET['filter-name']) ? $_GET['filter-name'] : "");
        $params.="&filter-rating=".(isset($_GET['filter-rating']) ? $_GET['filter-rating'] : "")."&filter-sort=".(isset($_GET['filter-sort']) ? $_GET['filter-sort'] : "");
        $params.="&filter-ascdesc=".(isset($_GET['filter-ascdesc']) ? $_GET['filter-ascdesc'] : "");

        if(isset($_GET['id'])){

            if(wpur_status_review($_GET['id'],1)){

                echo '<script>window.location = "admin.php?page=wpur_view_reviews&act=1&'.$params.'";</script>';

            }else{

                echo '<script>window.location = "admin.php?page=wpur_view_reviews&act=-1&'.$params.'";</script>';

            }

        }else if(isset($_GET['theids'])){

            $id_array = explode("|",$_GET['theids']);

            $ok = true;

            foreach($id_array as $id){

                if($id>0){

                    if(!wpur_status_review($id,1)){

                        $ok = false;

                    }

                }

            }

            if($ok){

                 echo '<script>window.location = "admin.php?page=wpur_view_reviews&acts=1&'.$params.'";</script>';

            }else{

                echo '<script>window.location = "admin.php?page=wpur_view_reviews&acts=-1&'.$params.'";</script>';

            }
        }else{
            echo '<script>window.location = "admin.php?page=wpur_view_reviews&act=-1&'.$params.'";</script>';
        }
    }
}

//Deactivate a review
function wpur_deact_review(){

    if( current_user_can('editor') || current_user_can('administrator') ){

        global $wpdb;

        $params= "pg=".(isset($_GET['pg']) ? $_GET['pg'] : "")."&filter-name=".(isset($_GET['filter-name']) ? $_GET['filter-name'] : "");
        $params.="&filter-rating=".(isset($_GET['filter-rating']) ? $_GET['filter-rating'] : "")."&filter-sort=".(isset($_GET['filter-sort']) ? $_GET['filter-sort'] : "");
        $params.="&filter-ascdesc=".(isset($_GET['filter-ascdesc']) ? $_GET['filter-ascdesc'] : "");

        if(isset($_GET['id'])){

            if(wpur_status_review($_GET['id'],0)){

                echo '<script>window.location = "admin.php?page=wpur_view_reviews&deact=1&'.$params.'";</script>';

            }else{

                echo '<script>window.location = "admin.php?page=wpur_view_reviews&deact=-1&'.$params.'";</script>';

            }

        }else if(isset($_GET['theids'])){

            $id_array = explode("|",$_GET['theids']);

            $ok = true;

            foreach($id_array as $id){

                if($id>0){

                    if(!wpur_status_review($id,0)){

                        $ok = false;

                    }
                }
            }

            if($ok){
                 echo '<script>window.location = "admin.php?page=wpur_view_reviews&deacts=1&'.$params.'";</script>';
            }else{
                echo '<script>window.location = "admin.php?page=wpur_view_reviews&deacts=-1&'.$params.'";</script>';
            }

        }else{
            echo '<script>window.location = "admin.php?page=wpur_view_reviews&deact=-1&'.$params.'";</script>';
        }
    }
}


//Change status of review
function wpur_status_review($id,$act){

    if (current_user_can( 'edit_posts' ) ) {

        global $wpdb;
        global $wpur_reviews;

        //If it is not already in this state then set it
        if( wpur_get_review_status($id)!=$act){

            $data = array(
                    '_active'    => (int)$act,
                    '_updated' => current_time( 'mysql' )
            );
            
            $format = array(
                    '%d',
                    '%s'
            );

            
            $success = $wpdb->update( 
                    $wpur_reviews, 
                    $data, 
                    array( 'id' => $id ), 
                    $format, 
                    array( '%d' ) 
            );

            return $success;

        }else{
            return false;
        }
    }else{
        return false;
    }
}


function wpur_get_review_status($id){

    global $wpdb;
    global $wpur_reviews;
    $curr_state = $wpdb->get_var($wpdb->prepare("SELECT _active from {$wpur_reviews} where id=%d;",array($id))); 
    return $curr_state;
}



//get review array
function wpur_getReviews($id,$act,$max){
    global $wpdb;
    global $wpur_reviews; 
    if( (int) $max > 0){
        $limit = "LIMIT 0,".$max;
    }else{
        $limit = "";
    }
    $sql = "SELECT _name,_review,_rating FROM {$wpur_reviews}  WHERE _pid=%d and _active=%d ORDER BY _order ASC {$limit};"; //_created
    $results = $wpdb->get_results($wpdb->prepare($sql, array($id,$act) ) );
    return $results;
}

//get av rating
function wpur_getAvRating($id,$act){
    global $wpdb;
    global $wpur_reviews;
    $sql = "SELECT _rating FROM {$wpur_reviews}  WHERE _pid=%d and _active=%d ORDER BY _created DESC;";
    $results = $wpdb->get_results($wpdb->prepare($sql, array($id,$act) ) );
    $total = count($results);
    $rating = 0;
    foreach($results as $result){
        $rating+= $result->_rating;
    }

    if(count($results)<1){
        return [-1,null];
    }else{
        $rating = floor($rating / $total);
        return [$rating,count($results)];
    }
}



//Ajax query to save new reviews from User Front End
function wpur_fe_save_review() {

   $type = sanitize_text_field($_POST['_review_type']);
   $pid = (int) $_POST['_review_pid'];
   $name = sanitize_text_field($_POST['_review_name']);
   $email = sanitize_email($_POST['_review_email']);
   $review = sanitize_text_field($_POST['_review_review']);
   $review = wp_kses( @$_POST['_review_review'], array( 
        'br' => array(),
        'em' => array(),
        'strong' => array(),
        'b' => array(),
   ));
   $order = -1;
   $rating = (int) $_POST['_review_rating'];
   $nonce = sanitize_text_field($_POST['_review_wpur_nonce']);

   if (defined('DOING_AJAX') && DOING_AJAX &&
        $type!="" && 
        $name!="" && 
        $review!="" && 
        $rating>0 && 
        wp_verify_nonce($nonce, '_review_submit_wpur_nonce_'.$pid.$type)  
    ){


        global $wpdb;
        global $wpur_reviews;

        if($type=="global"){
            $pid = 0;
            $type = "";
        }

        $data = array(
                        '_pid' => $pid,
                        '_type' => $type,
                        '_name' => $name,
                        '_email' => $email,
                        '_review' => $review,
                        '_rating' => $rating, 
                        '_order' => $order,                 
                        '_active'    => -1,
                        '_created' => current_time( 'mysql' ),
                        '_updated' => current_time( 'mysql' )
        );

                
        $format = array(
                        '%d',
                        '%s',
                        '%s',
                        '%s',
                        '%s',
                        '%d',
                        '%d',
                        '%d',
                        '%s',
                        '%s'
        );
        
        $success=$wpdb->insert( $wpur_reviews, $data, $format );
        $success = true;

        //echo $wpdb->last_error;
        if(!$success){
                echo "0";
        }else{
                wpur_reviewNotification(get_option("admin_email"),false);
                echo "1";
        }


   }else{
    echo "-1";
   }

   wp_die();
}
add_action( 'wp_ajax_wpur_save_review', 'wpur_fe_save_review' );
add_action( 'wp_ajax_nopriv_wpur_save_review', 'wpur_fe_save_review' );




//Create a review fom Admin area
function wpur_create_review($pid,$type,$name,$email,$message,$status,$rating,$order){
   $success = 0;

   if(  $name!="" && $message!="" && $rating!="" ){

        $success = true;
        global $wpdb;
        global $wpur_reviews;

        if($type=="global"){
            $pid = 0;
            $type = "";
        }else if($type=="page"){
            $pid = $pid;
            if($pid == 0){
                $success = false;
            }
        }else if($type=="edd"){
            $pid = $_POST['products'];
            if($pid == 0){
                $success = false;
            }
        }else if($type=="woo"){
            $pid = $_POST['woo_product'];
            if($pid == 0){
                $success = false;
            }
        }else{
            $success=false;
        }

   $_order = -1;

   if($order==0 ||$order>=1){
    $_order=$order;
   }


        if($success){

            $data = array(
                        '_pid' => (int) $pid,
                        '_type' => sanitize_text_field($type),
                        '_name' => sanitize_text_field($name),
                        '_email' => sanitize_email($email),
                        '_review' => sanitize_text_field($message),
                        '_rating' => (int) $rating,                
                        '_active'    => (int) $status,            
                        '_order'    => (int) $_order,
                        '_created' => current_time( 'mysql' ),
                        '_updated' => current_time( 'mysql' )
            );

                
            $format = array(
                        '%d',
                        '%s',
                        '%s',
                        '%s',
                        '%s',
                        '%d',
                        '%d',
                        '%d',
                        '%s',
                        '%s'
            );
            
            $success=$wpdb->insert( $wpur_reviews, $data, $format );

        }
   }
   if(!$success){
    $success = -1;
   }else{
    $success = 1;
   }
   return $success;
}

function wpur_show_reviews($atts){

        global $html;
        $html = "";        

        wp_enqueue_style('line-awesome-min', plugin_dir_url(dirname(__FILE__))."css/line-awesome.min.css");

        $a = shortcode_atts(array('type'=>'global', 'id'=>'', 'max'=>999, 'schema'=>'Brand', 'microdata'=>1),$atts);

        $schema = $a['schema'];
        if(strtolower($schema)!="product" && strtolower($schema)!="brand"){
            $schema = "Brand";
        }

        //More schema types coming soon


        global $the_reviews;

        $the_reviews = array();

        if($a['type']=="global"){
            $id = 0;
            $typ = "global";
            $productname = get_bloginfo('name');
        }else if($a['type']!="global" && $a['id']!='' && is_numeric($a['id'])){
            
            $typ = $a['type'];
            if($typ=="edd" && isset($a['id'])){
                $id = $a['id'];
                $productname =  wpur_get_edd_product( $id );
            }else if($typ=="edd_auto"){
                $id = get_the_ID();
                $productname =  wpur_get_edd_product( $id );
            }else if($typ=="woo" && isset($a['id'])){
                $id = $a['id'];
                if($id >=1){
                    $productname =  wpur_get_woo_product( $id );
                }
            }else if($typ=="woo_auto"){
                global $product;
                $id = $product->get_id();
                if($id >=1){
                    $productname =  wpur_get_edd_product( $id );
                }
            }else{
                $productname = get_bloginfo('name') ." - ". get_the_title( $id );
            }
        }else if($a['type']!="global" && ($a['id']=='' || !is_numeric($a['id']))){
            global $post;
            $id = $post->ID;
            $typ = $a['type'];//"edd";//wpur_get_type($id);
            if($typ=="edd"){
                $productname =  wpur_get_edd_product( $id );
            }else if($typ=="woo"){
                $productname =  wpur_get_woo_product( $id );
            }else{
                $productname = get_bloginfo('name') ." - ". get_the_title( $id );
            }
        }
        $max = $a['max'];



        //parse reviews---------------------------------------------    
              
        $review_Array = wpur_getReviews($id,1,$max);

        $reviews = wpur_parse_reviews($review_Array);

        //Display Reviews------------------------------------------------------------




        if(count($reviews)>0){

            $microdata_text_all = "";

            foreach($reviews as $review){

                $microdata_text = "";

                if($a['microdata']!=2){

                    $microdata_text ="<div itemscope itemtype='http://schema.org/".$schema."'>";
                        //Add the schema review
                        $microdata_text.= "<div itemprop='review' itemscope itemtype='http://schema.org/Review'>";
                            //Now add the schema rating
                            $microdata_text.= "<div itemprop='reviewRating' itemscope itemtype='http://schema.org/Rating'>";
                            $microdata_text.= '<meta itemprop="author" content="'.sanitize_text_field($review['name']).'" />';
                                $microdata_text.= "<meta itemprop='ratingValue' content='".sanitize_text_field($review['rating'])."' />";
                                $microdata_text.= "<meta itemprop='bestRating' content='5' /></span> ";
                                $microdata_text.= "<meta itemprop='worstRating' content='1' /></span> ";
                            $microdata_text .= "</div>";
                            ///////////////////////////
                            $microdata_text.= "<meta itemprop='itemreviewed' content='".$productname."' />";
                            $microdata_text.= "<meta itemprop='identifier' content='".$productname."' />";
                            $microdata_text.= "<meta itemprop='link' content='".$producturl."' />";
                            /*$microdata_text.= "<meta itemprop='logo' content='".get_custom_logo( $id )."' />";
                            $microdata_text.= "<meta itemprop='image' content='".get_custom_logo( $id )."' />";  */                  
                            $microdata_text.= "<meta content='".floor($review->_rating)."' />";
                            $microdata_text.= '<meta itemprop="author" content="'.sanitize_text_field($review['name']).'" />';
                            $microdata_text.= '<meta itemprop="reviewBody" content="'.stripslashes(sanitize_text_field($review['review'])).'" />';
                        $microdata_text .= "</div>";
                        if($schema == "Product"){
                            $microdata_text.= '<meta itemprop="name" content="'.$productname.'" />';

                        }
                    $microdata_text .= "</div>";

                    $microdata_text_all.=$microdata_text;

                }



                if($a['microdata']!=3){

                    array_push($the_reviews, array(stripslashes($review['name']),$review['ratingcode'],stripslashes($review['review'])));

                }


            }

        }

        if($a['microdata']!=3){


                if('' != locate_template( 'wpur/wpur_display.php' ) ){
                    include( locate_template( 'wpur/wpur_display.php') );
                }else{
                    include(plugin_dir_path(dirname(__FILE__))."template/wpur_display.php");
                }
            
                if('' != locate_template( 'wpur/css/wpur-global-style.css' ) ){
                  wp_enqueue_style('wpur-global-style', get_template_directory()."wpur/css/wpur-global-style.css");
                }else{
                 wp_enqueue_style('wpur-global-style', plugin_dir_url(dirname(__FILE__))."template/css/wpur-global-style.css");
                }


                if($a['microdata']!=2){
                    return $html.$microdata_text_all;
                }else{
                    return $html;
                }

        }else{
                return $microdata_text_all;
        }

}

function wpur_show_average_rating($atts){

        wp_enqueue_style('line-awesome-min', plugin_dir_url(dirname(__FILE__))."css/line-awesome.min.css");
                
        $a = shortcode_atts(array('type'=>'global', 'id'=>'', 'schema'=>'Brand', 'microdata'=>1 ),$atts);

        global $average_data;
        global $html;

        $html = "";

        $microdata = "";
        
        $average_data = array();

        if($a['type']=="global"){
                    $id = 0;
                    $typ = "global";
                    $productname = get_bloginfo('name');
        }else if($a['type']!="global" && $a['id']!='' && is_numeric($a['id'])){
                    
                    $typ = $a['type'];
                    if($typ=="edd" && isset($a['id'])){
                        $id = (int) $a['id'];
                        $productname =  wpur_get_edd_product( $id );
                    }else if($typ=="edd_auto"){
                        $id = get_the_ID();
                        $productname =  wpur_get_edd_product( $id );
                    }else if($typ=="woo" && isset($a['id'])){
                        $id = (int) $a['id'];
                        if($id >=1){
                            $productname =  wpur_get_woo_product( $id );
                        }
                    }else if($typ=="woo_auto"){
                        global $product;
                        $id = $product->get_id();
                        if($id >=1){
                            $productname =  wpur_get_edd_product( $id );
                        }
                    }else{
                        $productname = get_bloginfo('name') ." - ". get_the_title( $id );
                    }
                    $producturl = (isset($_SERVER['HTTPS']) ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
        }else if($a['type']!="global" && ($a['id']=='' || !is_numeric($a['id']))){
                    global $post;
                    $id = $post->ID;
                    $typ = $a['type'];//"edd";//wpur_get_type($id);
                    if($typ=="edd"){
                        $productname =  wpur_get_edd_product( $id );
                    }else if($typ=="woo"){
                        $productname =  wpur_get_woo_product( $id );
                    }else{
                        $productname = get_bloginfo('name') ." - ". get_the_title( $id );
                    }
                    $producturl = (isset($_SERVER['HTTPS']) ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
        }

        list($ratingamt,$totalcounts) = wpur_getAvRating($id,1);


        $schema = $a['schema'];
        if(strtolower($schema)!="brand" && strtolower($schema)!="product"){
            $schema = "Brand";
        }
               
        if($ratingamt!=-1){                

                $stars = "<div class='wpur-stars'>";

                for($i=0; $i<floor($ratingamt);$i++){

                    $stars .= "<span class='star fas fa-star'></span>"; 

                }

                if(floor($ratingamt) < $ratingamt){

                    $stars .= "<span class='star half fas fa-star-half'></span><span class='star half far fa-star overlapper'></span>"; 

                }

                for($i=floor($ratingamt); $i<5;$i++){

                    $stars .= "<span class='star far fa-star none'></span>"; 

                }
                $stars .= "</div>";

                if($a['microdata']!=2){

                    $microdata = "<div itemscope itemtype='http://schema.org/".$schema."'>";
                        $microdata.= "<div itemtype='http://schema.org/Rating'>";
                            $microdata.= "<meta itemprop='name' content='".$productname."' />";
                            $microdata.= "<meta itemprop='identifier' content='".$productname."' />";
                            $microdata.= "<meta itemprop='url' content='".$producturl."' />";
                            /*$microdata.= "<meta itemprop='logo' content='".get_custom_logo( $id )."' />";
                            $microdata.= "<meta itemprop='image' content='".get_custom_logo( $id )."' />";*/
                            $microdata.= "<div itemprop='aggregateRating' itemscope itemtype='http://schema.org/AggregateRating'>";
                                $microdata.= "<meta itemprop='ratingValue' content='".floor($ratingamt)."' />";
                                $microdata.= "<meta itemprop='bestRating' content='5' /></span> ";
                                $microdata.= "<meta itemprop='worstRating' content='1' /></span> ";
                                $microdata.= "<meta itemprop='ratingCount' content='".$totalcounts."' />";
                            $microdata .= "</div>";
                        $microdata .= "</div>";
                    $microdata .= "</div>";

                }

        }


        if($a['microdata']!=3){

                if($ratingamt!=-1){

                    $average_data = [$stars,$totalcounts];

                }else{
                    $average_data = null;
                }
                
                if('' != locate_template( 'wpur/wpur_average.php' ) ){
                    include( locate_template( 'wpur/wpur_average.php') );
                }else{
                    include(plugin_dir_path(dirname(__FILE__))."template/wpur_average.php");
                }

            
                if('' != locate_template( 'wpur/css/wpur-global-style.css' ) ){
                   wp_enqueue_style('wpur-global-style', get_template_directory()."wpur/css/wpur-global-style.css");
                }else{
                   wp_enqueue_style('wpur-global-style', plugin_dir_url(dirname(__FILE__))."template/css/wpur-global-style.css");
                }

                if($a['microdata']==1){
                    return $html.$microdata;
                }else if($a['microdata']==2){
                    return $html;
                }

        }else if($a['microdata']==3){

                return $microdata;

        }

}

function wpur_show_create_review($atts){

        global $html;
        global $required_data;
        global $stars_graphic;

        $html = "";
        $typ = "";
        $stars_graphic = "";
        

        wp_enqueue_style('line-awesome-min', plugin_dir_url(dirname(__FILE__))."css/line-awesome.min.css");

        $a = shortcode_atts(array('type'=>'global', 'id'=>''),$atts);

        if($a['type']=="global"){
                    $id = 0;
                    $typ = "global";
        }else if($a['type']!="global" && $a['id']!='' && is_numeric($a['id'])){                    
                    $typ = $a['type'];
                    if($typ=="edd" && isset($a['id'])){
                        $id = (int) $a['id'];
                    }else if($typ=="edd_auto"){
                        $id = get_the_ID();
                    }else if($typ=="woo" && isset($a['id'])){
                        $id = (int) $a['id'];
                    }else if($typ=="woo_auto"){
                        global $product;
                        $id = $product->get_id();
                    }
        }else if($a['type']!="global" && ($a['id']=='' || !is_numeric($a['id']))){
                    global $post;
                    $id = $post->ID;
                    $typ = $a['type'];               
        }

        if($typ!=""){

            $nonce = wp_create_nonce('_review_submit_wpur_nonce_'.$id.$typ);

            $required_data = "<input type='hidden' id='_review_wpur_nonce' name='_review_wpur_nonce' value='".$nonce."' /><input type='hidden' name='_review_pid' id='_review_pid'  value='".$id."' /><input type='hidden' name='_review_type' id='_review_type'  value='".$typ."' />";    

            $stars_graphic = "<div class='stars' id='rater'>";
            $rnd = rand(0,999)."_".rand(0,999);

            for($i=1; $i<=5;$i++){

                $stars_graphic .= "<div class='star la la-star-o none starselecter' data-rating='".$i."' data-rnd='".$rnd."' id='starover_".$rnd."_".$i."'></div>"; 

            }

            $stars_graphic .= "</div>";

            //echo "<script>var ajaxurl = '".admin_url('admin-ajax.php')."';</script>";

            wp_enqueue_script( 'wpur-create-fe-review-script', plugins_url( '../js/create-fe-review-script.js' , __FILE__ ), array('jquery'), '1.0.0', true );

            wp_localize_script( 'wpur-create-fe-review-script', 'wpur_submitter', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );

            if('' != locate_template( 'wpur/wpur_create.php' ) ){
                include( locate_template( 'wpur/wpur_create.php') );
            }else{
                include(plugin_dir_path(dirname(__FILE__))."template/wpur_create.php");
            }
                
            if('' != locate_template( 'wpur/css/wpur-global-style.css' ) ){
                wp_enqueue_style('wpur-global-style', get_template_directory()."wpur/css/wpur-global-style.css");
            }else{
                wp_enqueue_style('wpur-global-style', plugin_dir_url(dirname(__FILE__))."template/css/wpur-global-style.css");
            }

        }
        
        return $html;

}



function wpur_parse_reviews($review_Array){

            $reviews = [];
            $ratingamt_total = 0;
            
            foreach ($review_Array as $key) {

                    $rating_individual = $key->_rating;
                    $ratingamt_total+=$rating_individual;
                    $review_individual = ($key->_review);
                    $name_individual = ($key->_name);

                    $rating_individual_code = "<div class='wpur-stars'>";

                    for($i=0; $i<floor($rating_individual);$i++){

                        $rating_individual_code .= "<span class='star la la-star'></span>"; 

                    }

                    if(floor($rating_individual) < $rating_individual){

                        $rating_individual_code .= "<span class='star half la la-star-half-o'></span><span class='star half la la-star-o overlapper'></span>"; 

                    }

                    for($i=floor($rating_individual); $i<5;$i++){

                        $rating_individual_code .= "<span class='star la la-star-o none'></span>"; 

                    }

                    $rating_individual_code .="</div>";

                    $reviews[] = ["name"=>$name_individual,"review"=>$review_individual,"rating"=>$rating_individual,"ratingcode"=>$rating_individual_code];

            }
            return $reviews;
}



?>