<?php
/**
* Plugin Name: WP Ultimate Reviews Pro
* Plugin URI: https://www.jamestibbles.co.uk/wp-ultimate-reviews-pro/
* Description: Add reviews, testimonials and ratings to your site, pages and products quickly and easily. Reviews are Schema.org and Google compatible. Highly customisable.
* Version: 1.0.1
* Author: Owain James Tibbles
* Author URI: https://www.jamestibbles.co.uk
* Author Email: jamestibbles.jt@gmail.com
**/

defined( 'ABSPATH' ) or die( 'No script kiddies please!' );

include(plugin_dir_path( __FILE__ ) . '/functions/email.php');

include(plugin_dir_path( __FILE__ ) . '/functions/setup.php');

include(plugin_dir_path( __FILE__ ) . '/functions/admin.php');

include(plugin_dir_path( __FILE__ ) . '/functions/reviews-ratings.php');


global $wpur_version;

$wpur_version = "1.0.2";


register_activation_hook(__FILE__,'wpur_install'); //hook must be here in the main function
register_activation_hook(__FILE__,'wpur_activate');
register_activation_hook( __FILE__, 'wpur_admin_notice_example_activation_hook' );
add_action( 'admin_notices', 'wpur_admin_notice_example_notice' );


//handle requests - set up actions

add_action( 'plugins_loaded', 'wpur_translation_init');

add_shortcode( 'wpur-display-reviews', 'wpur_show_reviews' );

add_shortcode( 'wpur-display-average', 'wpur_show_average_rating' );

add_shortcode( 'wpur-display-form', 'wpur_show_create_review' );



//Allow translation
function wpur_translation_init() {
    load_plugin_textdomain( 'wpur', FALSE, basename( dirname( __FILE__ ) ) . '/languages/' );
}
